> For the complete documentation index, see [llms.txt](https://docs.pinot.apache.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pinot.apache.org/functions/array/arraytostring.md).

# arrayToString

Joins a string array into a single string using a delimiter.

## Signature

> arrayToString(values, delimiter)

> arrayToString(values, delimiter, nullString)

The 3-argument form replaces null or empty-string placeholder elements with `nullString` before joining.

## Usage Examples

These examples are based on Pinot's array function tests.

```sql
SELECT arrayToString(stringArray, '::') AS joinedValues
FROM myTable
```

Returns `3::2::10::6::1::12` when `stringArray` is `['3', '2', '10', '6', '1', '12']`.

```sql
SELECT arrayToString(stringArrayWithNulls, '::', '*') AS joinedValues
FROM myTable
```

Returns `3::2::10::6::1::12::*::*` when `stringArrayWithNulls` is `['3', '2', '10', '6', '1', '12', '', null]`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.pinot.apache.org/functions/array/arraytostring.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
